//
// Created by hoelshare on 22.05.17.
//

#include "GameClient.hpp"

void GameClient::createUIGameStart() {
    if (this->playerList) {
        delete this->playerList;
    }
    playerList = new PlayerListMenu(9);
    playerList->setLeftAction([=]() { this->player->prevWeapon(); });
    playerList->setRightAction([=]() { this->player->nextWeapon(); });
    playerList->setDownAction([=]() { this->player->reload(); });
    playerList->setEnterAction([=]() { this->player->shot(); });
    LaserMenuItem *healthMI = new LaserMenuItem([]() {}, "/heart.bmp");
    LaserMenuItem *armorMI = new LaserMenuItem([]() {}, "/armor.bmp");
    LaserMenuItem *ammoMI = new LaserMenuItem([]() {}, "/ammo.bmp");
    LaserMenuItem *nameMI = new LaserMenuItem([]() {}, nullptr);
    nameMI->setText(player->getNickname());
    player->setHealthMenuItem(healthMI);
    player->setArmorMenuItem(armorMI);
    player->setAmmoMenuItem(ammoMI);
    playerList->addMenuItem(healthMI);
    playerList->addMenuItem(armorMI);
    playerList->addMenuItem(ammoMI);
    playerList->addMenuItem(nameMI);
    ui->open(playerList);
}


void GameClient::startGame() {
#ifdef DEBUG
    Serial.printf("Start Game!");
#endif
    this->createUIGameStart();
}


void GameClient::joinGame(String ip) {
    badge->setVibrator(true);
    delay(200);
    badge->setVibrator(false);

    playerList->addMenuItem(new MenuItem(player->getNickname(), []() {}));

    ui->dispatchInput(badge->getJoystickState());
    ui->open(playerList);
    ui->draw();


    Serial.printf("Conn data:\n\tip: %s\n\tport: %d\n", ip.c_str(), SERVER_PORT);

    //client->connect(ip.c_str(), SERVER_PORT);
    Serial.printf("Trying to conncet!\n");
    if (!client->connect("192.168.42.175", 4803)){
        Serial.printf("Connect failed!\n");
    }
    Serial.printf("client->connect\n");
    client->print(player->getNickname());
    Serial.printf("client->print nickname\n");
    client->flush();
    Serial.printf("client->flush");

    Serial.printf("Receiving");
    String recv = client->readStringUntil('\n');
    Serial.printf("RECV: %s", recv.c_str());
}


void GameClient::update() {

    String lastHitBy;
    int lastDamage;

    if (wasHit(&lastHitBy, &lastDamage)){
        player->hit(lastDamage);

        tft.setCursor(20, 20);
        tft.print("Hit by " + lastHitBy);
    }

}

bool GameClient::wasHit(String* nick, int* damage, bool enable) {
    // TODO: Write 'real' code
    *nick = "otter";
    *damage = 10;

    return enable;

}